AppTitle "Metzler by SYSThern - BCC 17"
modus= Input ("Vollbild [1] oder Fenster [2]: ")

Graphics 1024,768,16,modus
SetBuffer BackBuffer()
Global frame_timer=CreateTimer(60)
;Bilder laden
Global hero  = LoadAnimImage("Grafik/hero.png",128,128,0,4)
Global shoti = LoadImage("Grafik/shot.png")
Global fire=LoadAnimImage("Grafik/fire.png",64,64,0,4)
Global world=LoadImage("Grafik/worldmorning.png")
Global enemy=LoadAnimImage("Grafik/alien1.png",256,128,0,2)
Global ammoi=LoadImage("Grafik/ammo.png")
Global blood=LoadImage("Grafik/blut.png")
Global enemy2=LoadAnimImage("Grafik/alien2.png",64,32,0,2)
Global blood2=LoadImage("Grafik/blut2.png")
Global menu_image=LoadImage("Grafik/menu.JPG")
Global button=LoadImage("Grafik/button.png")
Global button2=LoadImage("Grafik/button.png")
Global cursor=LoadImage("Grafik/cursor.png")
;Alpha Farbe der Bilder festlegen
MaskImage blood2,255,0,255
MaskImage blood,255,0,255
MaskImage hero,255,0,255 
MaskImage shoti,255,0,255
MaskImage enemy,255,0,255
MaskImage enemy2,255,0,255
MaskImage fire,255,0,255
MaskImage hero,255,0,255
MaskImage ammoi,255,0,255
MaskImage cursor,255,0,255
MaskImage button,255,0,255
MaskImage button2,255,0,255
;Bezugspunkt der Bilder setzen
MidHandle blood2
MidHandle blood
MidHandle button
MidHandle button2
;Schrift laden
Global font=LoadFont("Grafik/NEUROPOL.tff",48,0,0)
Global font2=LoadFont("Grafik/NEUROPOL.tff",48,1,0)
;Sounds laden
Global shot_sound=LoadSound("Sounds/machine_gun.wav")
Global dead_sound=LoadSound("Sounds/blaster.wav")
Global alien_sound=LoadSound("Sounds/plyrspwn.wav")
;Soundvolume festlegen
SoundVolume dead_sound,0.25
SoundVolume alien_sound,0.25
;Variablen
Global score=0
Global ammo=1000
Global hero_x = 448
Global hero_y = 600
Global shot_counter = 0   
Global monster_counter=0 
Global monster2_counter=0
Global shooting=1
Global frame
Global frame2
Global healt=400

;Types erstellen
Type shot          
 Field shot_x     
 Field shot_y     
End Type

Type monster
	Field monster_x
	Field monster_y
	
End Type 

Type monster2
	Field monster2_x
	Field monster2_y
End Type

;---------------------------------------------------------------------------
Function menu()
	SetBuffer BackBuffer()
While Not button_click<>0
Cls
	
If MouseDown(1) And ImagesOverlap (cursor,MouseX(),MouseY(),button,512,384) Then button_click=1
	If MouseDown(1) And ImagesOverlap (cursor,MouseX(),MouseY(),button2,512,512) Then End
	
	HidePointer 
	SetFont font
	DrawImage menu_image,0,0
	DrawImage button,512,348
	DrawImage button,512,512
	
	Color 0,0,0
	Text 435,325,"START"
	Text 445,490,"ENDE"
	Color 128,0,0
	Text 430,325,"START"
	Text 440,490,"ENDE"
	DrawImage cursor,MouseX(),MouseY()
	
	WaitTimer (frame_timer)
	Flip 
	If button_click=1
		button_click=0
		main()
	EndIf 
Wend
End Function 

menu()

Function main()
	SetBuffer BackBuffer()
	While Not KeyHit(1)	;Hauptschleife
	;Buffer lschen
		Cls     
	
	;Hintergrund kacheln,zeichnen und bewegen
	TileBlock world,0,world_y
	world_y=world_y +4
	
	;Funtionen einbinden
	createShot()
	updateTypes()
	
	;Timer fr die Animationen erstellen
	If MilliSecs() > timer+300
		timer=MilliSecs()
		frame=(frame+1) Mod 2
	EndIf
	
	If MilliSecs() > timer2+200
		timer2=MilliSecs()
		frame2=(frame2+1) Mod 2
	EndIf 
	
	If MilliSecs() > hero_timer + 200 Then 
		hero_timer = MilliSecs() 
		hero_frame = (hero_frame + 1) Mod 3 
	EndIf 
	
	If KeyDown(200)
		hero_y=hero_y-2
		If hero_y <=0 hero_y=0
	EndIf 
	If KeyDown(208)
		hero_y=hero_y+4
		If hero_y >=600 hero_y=600
	EndIf 
	
	If KeyDown(203) 
		hero_x=hero_x-4
		If hero_x <= 60 hero_x=60
	ElseIf KeyDown(205)
		hero_x=hero_x+4
		If hero_x >= 870 hero_x=870
	EndIf 
	
 	;Zeit-Timer
	If MilliSecs() >time1+1000 
		time1=MilliSecs()
		seconds=seconds+01
	EndIf 
	If seconds > 59
		seconds=00
		minutes=minutes+01
	EndIf 

	If minutes = 59
		minutes=00
		hours=hours+01
		If  24 > 24 Then 
			hours=00
			minutes=00
			seconds=00
		EndIf 
	EndIf
	
	;Spieler zeichnen
	DrawImage hero, hero_x, hero_y,hero_frame
	
	;HUD zeichnen
	DrawImage ammoi,900,650
	
	Color 0,0,0
	Rect (45,725,healt+10,40)
	Color 128,0,0
	Rect(50,730,healt,30)
	
	
	SetFont font2
	Color 0,0,0
	Text 674,5,"time:  "+hours+":"+minutes+":"+seconds
	Text 48,5,"score:"+score
	Text 50,720,"Healt"
	Text 873,700,ammo
	
	SetFont font
	Color 128,0,0
	Text 870,700,ammo
	Text 680,5,"time:  "+hours+":"+minutes+":"+seconds
	Text 50,5,"score:"+score
	
;Wenn F12 gedrckt wird, Screenshot anfertigen
If KeyHit(88) Then 
	SaveBuffer(FrontBuffer(),"screenshot" + Str$(screenshot) + ".bmp")
	screenshot = screenshot +1
EndIf

If healt<=0
	SetBuffer FrontBuffer()
	FlushKeys()
	SetFont font
	Text 380,384,"Du bist Tod!"
	Text 185,444,"Du hast "+score+" Monster erlegt!"
	Text 185,504,"Weiter mit beliebiger Taste"
	WaitKey
	loeschen()
	menu()
EndIf 

WaitTimer(frame_timer)
Flip 0
Wend ;Ende  der Hauptschleife
loeschen()
menu()
End Function

Function createShot();Function zum erstellen von Schssen wenn die Leertaste gedrckt wird
	
	monster2_counter = monster2_counter +1
	If monster2_counter=10
		monster_dead2=1
	EndIf 
	
	If monster_dead2=1
		monster2_counter=0
				
		e2.monster2 = New monster2                
		e2\monster2_x = Rnd(50,740) 
		e2\monster2_y = -200
		
		monster2_dead=0
				
		monster2_counter=0
	EndIf 
			
	For e2.monster2= Each monster2
	
		e2\monster2_Y=e2\monster2_y+8
		DrawImage enemy2,e2\monster2_x,e2\monster2_y,frame2
					
					
		If ImagesCollide(hero,hero_x,hero_y,hero_frame,enemy2,e2\monster2_x,e2\monster2_y,frame2)
			healt=healt-1
					
		EndIf 
		
			
			
		Next
		
       
	monster_counter = monster_counter +1
	If monster_counter=25
		monster_dead=1
	EndIf 
	If monster_dead=1
		monster_counter=0
		PlaySound alien_sound
		e.monster = New monster                
		e\monster_x = Rnd(50,740) 
		e\monster_y = -200
					
		monster_dead=0
					
		monster_counter=0
	EndIf 
	For e.monster= Each monster
	
		e\monster_y = e\monster_y +5 
		DrawImage enemy,e\monster_x,e\monster_y,frame
		
		If ImagesCollide(hero,hero_x,hero_y,hero_frame,enemy,e\monster_x,e\monster_y,frame)
			healt=healt-5	
		EndIf 
		
	Next
End Function

Function updateTypes()
	
    If shot_counter = 5 Then
		ammo=ammo-1
		If ammo<=0 ammo=0
			If ammo=0 shooting=0
				PlaySound shot_sound 
	
				a.shot = New shot                
	    		a\shot_x = hero_x   +95            
				a\shot_y = hero_y  
				
				shot_counter=0    
			End If
	For a.shot= Each shot
	
		a\shot_y = a\shot_y -5
		DrawImage shoti,a\shot_x,a\shot_y  
		
		If a\shot_y<-200 Delete a.shot
		Next 
		If KeyDown(57) And shooting=1 Then
			DrawImage fire,hero_x+65,hero_y-40,Rand(2,1)
			shot_counter = shot_counter +1
		EndIf 
		
	For a.shot = Each shot 
	For e.monster = Each monster                               
		If monster_y>800 
			Delete e.monster
		Else If ImagesCollide(shoti,a\shot_x,a\shot_y,0,enemy,e\monster_x,e\monster_y,0) 
			PlaySound dead_sound
			
			DrawImage blood,a\shot_x,a\shot_y
			
			score=score+1
			
			Delete  e.monster
			monster_dead=1
		EndIf 
	Next
	For e2.monster2 =Each monster2
		If monster2_y>800 
			Delete e2.monster2
		Else If ImagesCollide(shoti,a\shot_x,a\shot_y,0,enemy2,e2\monster2_x,e2\monster2_y,0) 
			PlaySound dead_sound
		
			DrawImage blood2,a\shot_x,a\shot_y
		
			score=score+1
		
			Delete e2.monster2
			monster_dead2=1
		EndIf
	Next
Next
End Function

Function loeschen()
	Cls
	world_y=0
	hero_x=448
	hero_y=600
	frame=0
	frame2=0
	hero_frame=0
	shot_counter=0
	monster_dead=0
	monster2_dead=0
	score=0
	minutes=0
	seconds=0
	hours=0
	healt=400
	ammo=1000
	shooting=1
	For e2.monster2=Each monster2
		e2\monster2_y=-200
		Delete e2
	Next
	For e.monster=Each monster
		e\monster_y=-200
		Delete e
	Next 
	For a.shot=Each shot
		a\shot_y=hero_y
		Delete a
	Next
		
End Function 








;~IDEal Editor Parameters:
;~C#Blitz3D