Global graph_x = 800
Global graph_y = 600

q = Input ("Vollbild [1] oder Fenster [2]: ")

Graphics graph_x,graph_y,0,q
SetBuffer BackBuffer()
SeedRnd MilliSecs()
AppTitle "CoD 2D"

Global hintergrund = LoadImage("map22.png")
Global hintergrund2 = LoadImage("hintergrund.png")
MaskImage hintergrund2,255,0,255
Global aua = LoadImage ("aua.png")
MaskImage aua,255,0,255
Global kreuz = LoadImage ("kreuz.png")
MaskImage kreuz,255,0,255
MidHandle kreuz
Global patrone = LoadImage ("16.png")
MaskImage patrone ,255,0,255

Global shot = LoadSound("barret shot.mp3")
Global leerschuss = LoadSound("leerschuss.mp3")
Global nachladen = LoadSound("nachladen.mp3")
Global death= LoadSound("gegner_schuss.mp3")

Type soldat
	Field sold
	Field pos_y
	Field pos_y_bew
	Field pos_x
	Field bild
	Field platz
	Field punkte
	Field bildhoehe
	Field ms_start
	Field ms_end
	Field shot
	Field down
End Type

Type blood
	Field x_blut
	Field y_blut
	Field blut_bild
	Field frame
	Field zeit
End Type

Dim Name$(11) 
Dim Score(11)
Dim soldat_bild(6)
Dim blut(3)

For i = 1 To 6
	soldat_bild(i) = LoadImage(i+".png")
	MaskImage soldat_bild(i),255,0,255
Next

For i = 1 To 3
	blut(i) =LoadAnimImage("blood"+i+".png",i*7+7,i*8+8,0,5)
	MaskImage blut(i), 255,0,255
	MidHandle blut(i)
Next

font = LoadFont("times new roman",30)
SetFont font

HidePointer

Global life = 100
Global aktuell
Global punkte
Global magazin = 10
Global futsch

timer = CreateTimer(60)
ms_start = MilliSecs()
startzeit = MilliSecs()

DrawImage hintergrund,0,0
Color 0,0,0
Rect 120,227,560,170
Color 255,255,255
Text 400,250,"Schiee die Soldaten mit der linken Maustaste ab",1,1
Text 400,290,"Benutze die rechte Maustaste zum nachladen",1,1
Color 0,255,0
Text 400,330,"Beliebige Taste startet das Spiel",1,1
Color 255,0,0
Text 400,370,"Drcke ESC zum beenden",1,1
Flip
WaitKey()
MoveMouse 400,300
Dim da(8)

While Not KeyHit (1) Or life <= 0
	
	ms_aktuell = MilliSecs()
	If ms_aktuell - ms_start > 800 Then
		
		e = 0
		For info.soldat = Each soldat
			da(e) = info\platz
			e = e + 1
		Next	
		
		info.soldat = New soldat
		info\platz = Zufallszahl(1,7,da(1),da(2),da(3),da(4),da(5),da(6),alt)
		alt = info\platz
		
		Select info\platz
			Case 1
				Restore platz1
			Case 2
				Restore platz2
			Case 3
				Restore platz3
			Case 4
				Restore platz4
			Case 5
				Restore platz5
			Case 6
				Restore platz6
			Case 7
				Restore platz7
		End Select
		Read info\pos_x,info\pos_y,info\sold,info\punkte
		info\bild = soldat_bild(info\sold)
		info\bildhoehe = ImageHeight(info\bild)
		info\pos_y_bew = info\pos_y + info\bildhoehe
		info\ms_start = MilliSecs()
		ms_start = MilliSecs()
	EndIf
	
	spielzeit = MilliSecs()
	aktuell = (spielzeit - startzeit)*.005
	DrawImage hintergrund,0,0
	Update_Soldat()
	DrawImage hintergrund2,15,283
	
	If MilliSecs() < futsch Then
		DrawImage aua,0,0
	EndIf
	
	Color 0,0,0
	Text 10,3,punkte
	Rect 9,569,502,17,0
	Color 170,0,0
	Rect 10,570,life*5,15
	For w = 1 To magazin
		DrawImage patrone,790-23*w,504
	Next
	DrawImage kreuz,MouseX(),MouseY()
	Flip 0
	WaitTimer(timer)
	Cls
Wend

FlushKeys
Datei = ReadFile("score.sav") 
If Not Datei = 0 Then ; Liste einlesen (falls vorhanden) 
	For i = 1 To 10
		Name$(i) = ReadString(datei)
		Score(i) = (ReadInt(datei)+13)/51
	Next 
	CloseFile Datei ; Datei schlieen
EndIf 

Cls
DrawImage hintergrund,0,0
DrawImage aua,0,0
Flip
If punkte > Score(10) Then ; Wenn neuer Highscore erreicht 
	Score(11) = punkte 
	Locate 20, 18
	Eingabe$ = Input("Du hast "+punkte+" punkte. Dein Name: ") 
	Name$(11) = LSet(Eingabe$,15) ; maximal 15 Zeichen erlaubt
Else
	Cls
	DrawImage hintergrund,0,0
	DrawImage aua,0,0
	Text 400,25,"Du hast "+punkte+" Punkte. Damit kommst du leider nicht in die Bestenliste.",1,1
	Flip
	WaitKey()
EndIf 

; --- Liste sortieren 
For I = 1 To 11 
	For J = I To 11 
		If Score(I) <= Score(J) Then ; "<" = grter zuerst 
			MerkerA  = Score(I) : Score(I) = Score(J) : Score(J) = MerkerA 
			MerkerB$ = Name$(I) : Name$(I) = Name$(J) : Name$(J) = MerkerB$ 
		EndIf 
	Next 
Next 

; --- Liste speichern 
Datei = WriteFile("score.sav") 

For i = 1 To 10 
	WriteString(datei,Name$(i))
	WriteInt(datei,Score(i)*51-13)
Next 

CloseFile Datei


; --- Liste laden + anzeigen 
Datei = ReadFile("score.sav")

Cls
DrawImage hintergrund,0,0
Color 170,0,0
Rect 200,50,400,480
Color 25,25,25
Rect 205,55,390,470
Color 170,0,0
Rect 200,125,400,5
Color 170,0,0
Text 400,90, "Highscore:" ,1,1

e=150
For i = 1 To 10
	Name$(i) = ReadString(datei)
	Score(i) = (ReadInt(datei)+13)/51
	Text 250,e, Name$(i)
	Text 510,e, Score(i)
	e=e+35
Next
Flip
CloseFile Datei 
WaitKey()

Function Update_Soldat() 
	mh = MouseHit(1)
	If MouseHit(2) Then 
		PlaySound nachladen
		If magazin > 0 Then punkte = punkte - magazin
		magazin = 10
	EndIf
	For info.soldat = Each soldat
		If info\pos_y_bew > info\pos_y And info\shot = 0 Then
			info\pos_y_bew  = info\pos_y_bew  - 5
		Else
			info\ms_end = MilliSecs()
			If info\ms_end - info\ms_start > 1500 - aktuell Then
				If info\shot = 0 Then
					info\bild = soldat_bild(info\sold+3)
					life = life - 20
					futsch = MilliSecs() + 250
					PlaySound (death)
					info\shot = 1
				EndIf
				If info\ms_end - info\ms_start > 2000 Then
					If info\down = 0 Then
						info\bild = soldat_bild(info\sold)
						info\down = 1
					EndIf
					If info\pos_y_bew < info\pos_y + info\bildhoehe Then
						info\pos_y_bew  = info\pos_y_bew  + 5
					EndIf
				EndIf
			EndIf
		EndIf
		DrawImage info\bild,info\pos_x,info\pos_y_bew 
		If mh And magazin > 0 Then
			If ImageRectCollide (info\bild,info\pos_x,info\pos_y_bew ,0,MouseX()-5,MouseY()-5,10,10) Then
				punkte = punkte + info\punkte
				info1.blood = New blood
				info1\x_blut = MouseX()
				info1\y_blut = MouseY()
				info1\blut_bild = blut(info\sold)
				Delete info.soldat
			EndIf
		ElseIf info\pos_y_bew >= info\pos_y + info\bildhoehe And info\down = 1 Then
			Delete info.soldat
		EndIf
	Next
	For info1.blood = Each blood
		DrawImage info1\blut_bild,info1\x_blut,info1\y_blut,info1\frame
		If MilliSecs() > info1\zeit + 20 Then
			info1\zeit=MilliSecs()
			info1\frame = info1\frame + 1
		EndIf
		If info1\frame > 4 Then Delete info1.blood
	Next
	If mh And magazin > 0 Then 
		PlaySound shot
		magazin = magazin - 1
	ElseIf mh
		PlaySound leerschuss
	EndIf
End Function

Function Zufallszahl(min,max,a1,a2,a3,a4,a5,a6,a7)
	While zahl = a1 Or zahl = a2 Or zahl = a3 Or zahl = a4 Or zahl = a5 Or zahl = a6 Or zahl = a7
		zahl = Rand(min,max)
	Wend
	Return zahl
End Function

.platz1
Data 38,212,3,5
.platz2
Data 644,215,3,5
.platz3
Data 341,279,2,8
.platz4
Data 273,281,2,8
.platz5
Data 229,258,2,8
.platz6
Data 430,241,1,10
.platz7
Data 498,241,1,10
;~IDEal Editor Parameters:
;~C#Blitz3D